clear;

mkoctfile --mex MPCL.c

% Carregar Dados

synthtreina;
d = Xtr(3,:);
d = d + 1;
Xtr = Xtr(1:2,:);

synthteste;
dteste=Xteste(3,:);
dteste = dteste + 1;
Xteste=Xteste(1:2,:);

if 0
    % MP/CL

    Hipercaixas_MPCL=treinaMPCLn(Xtr,d);
    HC_MPCL=clearboxes(Hipercaixas_MPCL);

    for i=1:size(Xtr,2)
      ytr(i)=MPCLn(Xtr(:,i),HC_MPCL);
    end
	
    for i=1:size(Xteste,2)
      yte(i)=MPCLn(Xteste(1:2,i),HC_MPCL);
    end

    MPCL_ERRO_TR = 100*sum(abs((d)~=ytr))/size(Xtr,2)

    MPCL_ERRO_TE = 100*sum(abs((dteste)~=yte))/size(Xteste,2)

    MPCL_N = size(HC_MPCL{1},2)+size(HC_MPCL{2},2)
end

% MP/CGL

M = 2;
N = size(Xtr,1);
tic
[HC_MPCGL, Error] = gan([3 3], Xtr, d, Xtr, d);
toc
for i=1:size(Xteste,2)
    yteste(i)=MPCLn(Xteste(:,i),HC_MPCGL);
end

for i=1:size(Xtr,2)
    ytreino(i)=MPCLn(Xtr(:,i),HC_MPCGL);
end

MPCGL_ERRO_TR = 100*sum(abs((d)~=ytreino))/size(Xtr,2)

MPCGL_ERRO_TE = 100*sum(abs((dteste)~=yteste))/size(Xteste,2)

MPCGL_N = N*M

% Plots

figure(1)
clf;
hold on;
for i = 1:size(HC_MPCGL{1},2)
        fill([HC_MPCGL{1}(1,i);HC_MPCGL{1}(1,i);HC_MPCGL{1}(3,i);HC_MPCGL{1}(3,i)],[HC_MPCGL{1}(2,i);HC_MPCGL{1}(4,i);HC_MPCGL{1}(4,i);HC_MPCGL{1}(2,i)],'y')
end
for i = 1:size(HC_MPCGL{2},2)
        fill([HC_MPCGL{2}(1,i);HC_MPCGL{2}(1,i);HC_MPCGL{2}(3,i);HC_MPCGL{2}(3,i)],[HC_MPCGL{2}(2,i);HC_MPCGL{2}(4,i);HC_MPCGL{2}(4,i);HC_MPCGL{2}(2,i)],'g')
end
plot(Xteste(1,find(dteste==1)),Xteste(2,find(dteste==1)),'*b');
hold on;
plot(Xteste(1,find(dteste==2)),Xteste(2,find(dteste==2)),'*r');
grid on;
title('Hiperboxes MP/GA and Test Data');
print -depsc MPGA3x3_te

figure(3)
clf;
hold on;
for i = 1:size(HC_MPCGL{1},2)
        fill([HC_MPCGL{1}(1,i);HC_MPCGL{1}(1,i);HC_MPCGL{1}(3,i);HC_MPCGL{1}(3,i)],[HC_MPCGL{1}(2,i);HC_MPCGL{1}(4,i);HC_MPCGL{1}(4,i);HC_MPCGL{1}(2,i)],'y')
end
for i = 1:size(HC_MPCGL{2},2)
        fill([HC_MPCGL{2}(1,i);HC_MPCGL{2}(1,i);HC_MPCGL{2}(3,i);HC_MPCGL{2}(3,i)],[HC_MPCGL{2}(2,i);HC_MPCGL{2}(4,i);HC_MPCGL{2}(4,i);HC_MPCGL{2}(2,i)],'g')
end
plot(Xtr(1,find(d==1)),Xtr(2,find(d==1)),'*b');
hold on;
plot(Xtr(1,find(d==2)),Xtr(2,find(d==2)),'*r');
grid on;
title('Hiperboxes MPCGL and Train Data');
print -depsc MPGA3x3_tr

figure(2)
clf;
plot(Error');
grid on;
title('Error');
xlabel('Generations');
ylabel('Error');
legend('Minimum','Medium','Maximum');
axis([0 101 0 1]);
print -depsc Evo_MPGA3x4.eps
% Salvar Resultado Final
%save ripley_artigo.mat;

% MPCL_ERRO_TR = 0 %
% MPCL_ERRO_TE = 10,2 %
% MPCL_N = 55
% MPCGL_ERRO_TR = 14,4 %
% MPCGL_ERRO_TE = 10,5 %
% MPCGL_N = 4
